﻿package aibase
{
	internal class AlignStrategy implements FaceStrategy
	{
		private var satisDelta:Number;
		private var slowDelta:Number;
		private var timeToTarget:Number;
		internal static const INSTANCE:FaceStrategy= new AlignStrategy(Math.PI/32, Math.PI/25, 1.25);

		function AlignStrategy(satis:Number, slow:Number, TTT:Number)
		{
			satisDelta = satis;
			slowDelta = slow;
			timeToTarget = TTT;
		}
		public function getName():String
		{
			return "D_ALIGN";
		}

		public function getFace(a:Bot, b:Bot, target:Vec2f):Number
		{
			var rotation:Number = b.kinematic.orientation - a.kinematic.orientation;
			rotation = Utils.mapToRange(rotation,-Math.PI,Math.PI, 2.0*Math.PI);
			rotation = rotation - a.kinematic.rotation;
			var rotationSize:Number = Math.abs(rotation);
			if (rotationSize < satisDelta)
			{
				return 0;
			}
			var targetRotation:Number;
			if (rotationSize > slowDelta)
			{
				targetRotation = a.kinematic.maxRotation;
			}
			else
			{
				targetRotation = a.kinematic.maxRotation * (rotationSize)/(slowDelta);
			}
			targetRotation *= rotation/rotationSize;

			targetRotation /= timeToTarget;

			if (Math.abs(targetRotation) > a.kinematic.maxAngularAcceleration)
			{
				targetRotation = a.kinematic.maxAngularAcceleration;
				if (targetRotation < 0)
				{
					targetRotation *= -1;
				}
			}
			return targetRotation;
		}
	}
}