﻿package aibase
{
	import flash.display.MovieClip;
	import flash.events.Event;
	public class Bot extends MovieClip
	{
		internal var kinematic:Kinematic;
		internal var strategy:Strategy;
		internal var faceStrategy:FaceStrategy;
		
		public var myPath : SimplePath;
		
		internal var pathParam : int;  // used to keep track of where we are on the path
		
		private var deltaToParam : Number = 40; // Radius we can be within and accept our distance from the path point
		private var debug : Boolean = true;
		
		public function Bot()
		{
			kinematic=new Kinematic(new Vec2f(this.x,this.y),0,Vec2f.zero(),0);
			strategy = NoOpStrategy.INSTANCE;
			//faceStrategy = DynamicFace.INSTANCE;
			//faceStrategy = AlignStrategy.INSTANCE;
			faceStrategy = DynamicFace.INSTANCE;
			myPath = null;
		}

		public function update():void
		{
			var steer:SteeringOutput = strategy.getSteering(this,BotArena.Hero);
			//trace(steer.toString());
			//dtrace("\t\tUPDATE() steer = " + steer.toString());
			
			this.kinematic.update(steer,1/60);
			updateKinematics();
		}
		
		
		public function updatePath():void
		{
			dtrace("\tInside updatePath()");
			
			var pathPointAsBot : Bot = new Bot();
			var goneToLast : Boolean = false;
			
			if (myPath == null){
				dtrace("\t\tmyPath == null");
				// Follow the hero
				update();
			}
			
			//strategy = "SEEK";
			if (myPath != null){
				
				pathPointAsBot.kinematic.position.x = myPath.points[pathParam].x;
				pathPointAsBot.kinematic.position.y = myPath.points[pathParam].y;
				
				// if we are withing delta of path_param, advance the parameter 
				var distance : Number = Utils.Vec2fLength(Utils.difference(pathPointAsBot.kinematic.position, this.kinematic.position));
		
				dtrace("\t\pathPointAsBot.kinematic.position.x = " + pathPointAsBot.kinematic.position.x);
				dtrace("\t\pathPointAsBot.kinematic.position.y = " + pathPointAsBot.kinematic.position.y);
		
				dtrace("\t\tdistance = " + distance);
				dtrace("\t\tdeltaToParam = " + deltaToParam);
				
				dtrace("\n\t\tpathParam = " + pathParam);
				dtrace("\t\tmyPath.points.length = " +  myPath.points.length);
				
				// if we are within a certain distance of the point, other than the last one, advance the pathParam
				if ((distance < deltaToParam) && (pathParam < (myPath.points.length - 1))){
					dtrace("\t\tIncrimenting pathParam");
					pathParam = pathParam + 1;
				}
				
				// if we are within a certain distance of the last point
				if (pathParam == (myPath.points.length -1) && (goneToLast == false)){
					goneToLast = true;
				}
				
				if ((pathParam == (myPath.points.length - 1) &&(goneToLast == true))){
					dtrace("\t\tFollowing shepherd");
					update();
					return;
				}
				
				/*
				if ((distance < deltaToParam) && (pathParam == myPath.points.length)){
					// Follow the hero
					update();
				}
				*/
					
				var steer:SteeringOutput = strategy.getSteering(this,pathPointAsBot);
				this.kinematic.update(steer,1/60);
				updateKinematics();

			}
		}
		
		public function updateKinematics():void
		{
			x=kinematic.position.x;
			y=kinematic.position.y;
			rotation=kinematic.orientation*Utils.RADIANS_TO_DEGREES;
		}
		
		// debug printing routine
		private function dtrace(input : String):void
		{
			if (debug == true){
				trace(input);
			}
		}
	}
}