﻿package aibase
{
	import flash.display.Sprite;
	import fl.controls.List;
	import fl.controls.CheckBox;
	import flash.display.*;
	import flash.events.*;
	//the main class

	public class BotArena extends Sprite
	{
		static const BOT_COUNT:Number = 9;
		internal var botList:Array = new Array(BOT_COUNT);
		static var Hero:Bot;
		//    internal var botList:Vector.<Bot> = new Vector.<Bot>();
		//var v:Vector.<String> = Vector.<String>(["Hello", "World"]);
		static var INSTANCE:BotArena;
		static var TORUS_CHECKBOX:fl.controls.CheckBox;
		
		private var debug : Boolean = true; // Are we printing debug messages?
		private var myPath : SimplePath;
		private var myDog : SheepDog;
		
		internal function dtrace(input : String){
			if (debug == true){
				trace(input);
			}
		}
		
		internal static function initFlocking():Strategy
		{
			var strats = new Array(3);
			var weights = new Array(3);
			strats[0] = DynamicSeperation.INSTANCE;
			weights[0] = .4;
			strats[1] = DynamicCohesion.INSTANCE;
			weights[1] = .4;
			strats[2] = FlockingAlignment.INSTANCE;
			weights[2] = .2;
			return new SteeringCombinator(strats,weights,"FLOCKING");

		}
		internal static function initFlockPlusFlee()
		{
			var strats = new Array(2);
			var weights = new Array(2);
			strats[0] = FLOCKING_INSTANCE;
			weights[0] = .7;
			strats[1] = LimitedDynamicFlee.INSTANCE;
			weights[1] = .3;
			return new SteeringCombinator(strats,weights,"FLOCKING_PLUS_FLEE");
		}
		internal static function initFlockFleeAvoid()
		{
			var strats = new Array(3);
			var weights = new Array(3);
			strats[0] = FLOCKING_INSTANCE;
			weights[0] = .6;
			strats[1] = LimitedDynamicFlee.INSTANCE;
			weights[1] = .3;
			strats[2] = CollisionAvoidance.INSTANCE;
			weights[2] = .1;
			return new SteeringCombinator(strats,weights,"FLOCK_FLEE_AVOID");
		}
		internal static function initFlockFleeAvoidWall()
		{
			var strats = new Array(4);
			var weights = new Array(4);
			
			
			strats[0] = FLOCKING_INSTANCE;
			weights[0] = .6;
			strats[1] = LimitedDynamicFlee.INSTANCE;
			weights[1] = .2;
			strats[2] = CollisionAvoidance.INSTANCE;
			weights[2] = .3;
			strats[3] = WallAvoidance.INSTANCE;
			weights[3] = .5;
		    strats[4] = CenterAttraction.INSTANCE;
			weights[4] = .1;
			return new SteeringCombinator(strats,weights,"FLOCK_FLEE_AVOID_WALL");
		}
		
		static var FLOCKING_INSTANCE:Strategy = initFlocking();
		static var FLOCK_FLEE_INSTANCE:Strategy = initFlockPlusFlee();
		static var FLOCK_FLEE_AVOID:Strategy = initFlockFleeAvoid();
		static var FLOCK_FLEE_AVOID_WALL:Strategy = initFlockFleeAvoidWall();
		
		public function BotArena()
		{
			INSTANCE = this;
			dtrace("Bot Arena Instantiate");

			dtrace("Creating instance of SimplePath");
			myPath = new SimplePath();
			
			myDog = new SheepDog();
			myDog.x = 400;
			myDog.y = 400;
			myDog.scaleX = 0.2;
			myDog.scaleY = 0.2;
			myDog.strategy = DynamicSeek.INSTANCE;
			addChild(myDog);
			
			
			initListeners();
			initBots();
			initWalls(true);	
			setStrategy(FLOCK_FLEE_AVOID_WALL);

		}
		
		internal function initWalls(force:Boolean):void
		{
			if(TORUS_CHECKBOX.selected || force)
			{
			var arr:Array = new Array(4);
			//top
			arr[0] = new Wall(new Vec2f(0,0),new Vec2f(Utils.WIDTH, 0), new Vec2f(0,1));
			//left
			arr[1] = new Wall(new Vec2f(0,0), new Vec2f(0,Utils.HEIGHT), new Vec2f(1,0));
			//right
			arr[2] = new Wall(new Vec2f(Utils.WIDTH,0), new Vec2f(Utils.WIDTH,Utils.HEIGHT),new Vec2f(1,0));
			//bottom
			arr[3] = new Wall(new Vec2f(0,Utils.HEIGHT), new Vec2f(Utils.WIDTH,Utils.HEIGHT),new Vec2f(0,1));
			WallAvoidance.INSTANCE.setWalls(arr);
			}
			else
			{
				WallAvoidance.INSTANCE.setWalls(new Array(0));
			}
		}
		
		internal function debugs():void
		{
			var direction:Vec2f = Utils.normalize(new Vec2f(1,-.5));
			var orientation:Number = Utils.orientationFromDirection(direction);
			trace(direction.toString() + ": "+orientation);
			trace("Direction back: "+Utils.directionFromOrientation(orientation).toString());

			var tmp:Bot = new MBot();
			tmp.x = 200;
			tmp.y = 400;
			tmp.rotation = orientation*Utils.RADIANS_TO_DEGREES;
			addChild(tmp);

		}
		internal function initBots():void
		{
			//EventDispatcher.initialize(this);
			var tmp:Bot;

			//stage isn't init'd yet.

			for (var ct = 0; ct<BOT_COUNT; ct++)
			{
				tmp = new MBot();

				tmp.kinematic.position = new Vec2f(Math.floor(Math.random() * 200),Math.floor(Math.random() * 200));
				tmp.visible = true;
				addChild(tmp);
				botList[ct] = tmp;
			}
			DynamicSeperation.INSTANCE.setNeighbors(botList);
			DynamicCohesion.INSTANCE.setNeighbors(botList);
			FlockingAlignment.INSTANCE.setNeighbors(botList);
			CollisionAvoidance.INSTANCE.setNeighbors(botList);

			Hero = new HBot();

			Hero.kinematic = new HeroKinematic(new Vec2f(200,200),0,Vec2f.zero(),0);
			Hero.kinematic.maxSpeed = 100;
			Hero.visible = true;
			addChild(Hero);


			setStrategy(DynamicSeek.INSTANCE);
			setFace(DynamicLook.INSTANCE);
		}
		import fl.controls.List;
		function initListeners():void
		{
			this.addEventListener(Event.ENTER_FRAME, update);
			parent.addEventListener(MouseEvent.MOUSE_DOWN, LeftClickHandler);
			
			keyInit();

			var f:fl.controls.List = new fl.controls.List();
			f.x = 500;
			f.y = 30;
			f.height = 200;
			f.width = 150;
			f.addItem({label:"Seek", data: "SEEK"});
			f.addItem({label:"Flee", data: "FLEE"});
			f.addItem({label:"Seperation", data: "SEPERATION"});
			f.addItem({label:"Cohesion", data: "COHESION"});
			f.addItem({label:"Flocking", data: "FLOCKING"});
			f.addItem({label:"Flock + Flee", data: "FLOCK_FLEE"});
			f.addItem({label:"Flock + flee + avoid",data: "FLOCK_FLEE_AVOID"});
			f.addItem({label:"Flock+flee+avoid+wall",data: "FLOCK_FLEE_AVOID_WALL"});
			f.focusEnabled = false;
			f.selectedIndex = 7;
			f.addEventListener(Event.CHANGE, processStratChange);

			
			TORUS_CHECKBOX = new fl.controls.CheckBox();
			TORUS_CHECKBOX.x = 500;
			TORUS_CHECKBOX.y = 300;
			TORUS_CHECKBOX.label = "Torus";
			TORUS_CHECKBOX.selected = false;
			addChild(TORUS_CHECKBOX);
			TORUS_CHECKBOX.addEventListener(Event.CHANGE, processTorusChange);
			
			addChild(f);

			//var stratList:fl.controls.List = getChildByName("StrategyList");
			//stratList.addEventListener(Event.CHANGE, processStratChange);
		}
		
		// Method to add points to our path for visual debugging 
		private function LeftClickHandler(event:MouseEvent):void{
			dtrace("INSIDE LeftClickHandler");
			// I only care about left clicks
			
			var target:* = event.target;
			
			dtrace("\ttarget.mouseX = " + target.mouseX);
			dtrace("\ttarget.mouseY = " + target.mouseY);
			
			// This is to visualize the path box
			var myPathBox : Path_Box = new Path_Box();
			// set it's position to where we clicked
			myPathBox.x = event.stageX;
			myPathBox.y = event.stageY;
			// scale it down to something reasonable
			myPathBox.scaleX = 0.1;
			myPathBox.scaleY = 0.1;
			// display it
			this.addChild(myPathBox);
			
			dtrace("\tmyPath.points.length = " + myPath.points.length);
			dtrace("\tBEFORE adding point to path");
			// Add it to the path 
			myPath.addPoint(event.stageX, event.stageY);
			dtrace("\tmyPath.points.length = " + myPath.points.length);
			dtrace("\AFTER adding point to path");
			
			// If it is the second point or greater, create a line between it and the previous
			// point
			
			if (myPath.points.length == 1){
				//graphics.lineStyle(15);
				//graphics.lineTo(target.mouseX, target.mouseY);
				graphics.moveTo(target.mouseX, target.mouseY);
				//graphics.clear();
			}
			
			
			if (myPath.points.length > 1){
				//graphics.clear();
			
				//define line width in pixels
				graphics.lineStyle(15);
			
				//draw lines from the start (above) to the mouse position
				graphics.lineTo(event.stageX, event.stageY);
				//move the drawing pen.
				//graphics.moveTo(myPath.points[(length)].x, myPath.points[(length)].y);
				
				myDog.myPath = myPath;
			} // end if 
		}
		
		function processTorusChange(e:Event)
		{
			initWalls(false);		
		}
		
		function processStratChange(e:Event)
		{
			var sel:String = e.target.selectedItem.data;
			if (sel == "SEEK")
			{
				setStrategy(DynamicSeek.INSTANCE);
				trace("SEEK");
			}
			else if (sel == "FLEE")
			{
				setStrategy(LimitedDynamicFlee.INSTANCE);
				trace("FLEE");
			}
			else if (sel == "SEPERATION")
			{
				setStrategy(DynamicSeperation.INSTANCE);
				trace("SEPERATION");
			}
			else if (sel == "COHESION")
			{
				setStrategy(DynamicCohesion.INSTANCE);
				trace("COHESION");
			}
			else if (sel == "FLOCKING")
			{
				setStrategy(FLOCKING_INSTANCE);
				trace("FLOCKING");
			}
			else if (sel == "FLOCK_FLEE")
			{
				setStrategy(FLOCK_FLEE_INSTANCE);
				trace("FLOCK+FLEE");
			}
			else if (sel == "FLOCK_FLEE_AVOID")
			{
				setStrategy(FLOCK_FLEE_AVOID);
				trace("FLOCK_FLEE_AVOID");
			}
			else if (sel == "FLOCK_FLEE_AVOID_WALL")
			{
				setStrategy(FLOCK_FLEE_AVOID_WALL);
				trace("FLOCK_FLEE_AVOID_WALL");
			}
			else
			{
				trace("UNKONWNN: "+sel);
			}
		}
		function setStrategy(strat:Strategy):void
		{
			for (var ct = 0; ct<BOT_COUNT; ct++)
			{
				botList[ct].strategy = strat;
			}
		}
		function setFace(strat:FaceStrategy):void
		{
			for (var ct = 0; ct<BOT_COUNT; ct++)
			{
				botList[ct].faceStrategy = strat;
			}
		}
		function updateHeroMovement():void
		{
			var steer:SteeringOutput = new SteeringOutput(new Vec2f(0,0),0,1);
			if (keys[37])
			{
				steer.linear.x = -Hero.kinematic.maxSpeed;
			}
			else if (keys[39])
			{
				steer.linear.x = Hero.kinematic.maxSpeed;
			}
			else if (keys[38])
			{
				steer.linear.y = -Hero.kinematic.maxSpeed;
			}
			else if (keys[40])
			{
				steer.linear.y = Hero.kinematic.maxSpeed;
			}
			steer.angular = Utils.orientationFromDirection(steer.linear);
			Hero.kinematic.update(steer,1/60);
			Hero.updateKinematics();
		}
		
		function updateDogMovement():void{
			
			
		}
		
		function update(e:Event):void
		{
			
			//Hero.update();
			updateHeroMovement();
			
			// We want the dog to follow the hero, unless there is a path
			myDog.updatePath();
			
			// if there is a path
			if (myPath != null){
				if (myPath.points.length >= 1){
					var tmpBox : Bot = new Bot();
					tmpBox.x = myPath.points[0].x;
					tmpBox.y = myPath.points[0].y;
				
					//var tmpDynamicSeek : DynamicSeek = new DynamicSeek();
				
					//myDog.strategy = tmpDynamicSeek;
				}
			}
			

			Utils.WIDTH = 640;//stage.fullScreenWidth;
			Utils.HEIGHT = 480;//stage.fullScreenHeight;

			for (var ct = 0; ct<BOT_COUNT; ct++)
			{
				botList[ct].update();
			}
		}
		// keyboard event handling
		private var keys:Array = new Array(256);
		private function keyInit():void
		{
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDown);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUp);
		}
		private function keyDown(e:KeyboardEvent):void
		{
			trace(e.keyCode);
			keys[e.keyCode] = true;
		}
		private function keyUp(e:KeyboardEvent):void
		{
			keys[e.keyCode] = false;
		}
	}
}