﻿package aibase
{
	internal class DynamicSeperation implements GroupStrategy
	{
		public static  const INSTANCE:GroupStrategy = new DynamicSeperation(DynamicSeek.INSTANCE);
		public function getName():String
		{
			return "D_SEPERATION";
		}
		private var neighbors:Array = null;
		private var moveDelegate:Strategy;

		public function DynamicSeperation(_moveDelegate:Strategy)
		{
			moveDelegate = _moveDelegate;
		}
		public function setNeighbors(_others:Array):void
		{
			neighbors = _others;
		}
		public function getSteering(a:Bot, b:Bot):SteeringOutput
		{
			var direction:Vec2f = new Vec2f(0,0);

			for (var x:int=0; x<neighbors.length; x++)
			{
				var n:Bot = neighbors[x];
				var currDir:Vec2f;
				var currDist:Number;
				var weight:Number;
				if (n == a)
				{
					continue;
				}//don't include yourself
				currDir = Utils.difference(n.kinematic.position, a.kinematic.position);
				currDist = Utils.l2(currDir);
				if (currDist > Globals.getPersonalSheepSpace())
				{
					continue;
				}

				weight = 1.0-(currDist/Globals.getPersonalSheepSpace());
				direction = Utils.add(direction, Utils.mult(currDir,weight));
			}
			/*if(!Globals.TORUS())
			{
			var wallAversion:Number = Globals.wallAversion();
			var dist = Utils.WIDTH - a.kinematic.position.x;
			if (a.kinematic.position.x < Globals.getPersonalSheepSpace())
			{
			currDir = new Vec2f(1,0);
			currDist = a.kinematic.position.x;
			weight = 1.0 - (currDist/Globals.getPersonalSheepSpace());
			direction = Utils.add(direction, Utils.mult(currDir,weight*wallAversion));
			}
			
			
			
			else if(dist < Globals.getPersonalSheepSpace())
			{
			currDir = new Vec2f(-1,0);
			currDist = dist;
			weight = 1.0 - (currDist/Globals.getPersonalSheepSpace());
			direction = Utils.add(direction, Utils.mult(currDir,weight*wallAversion));
			}
			
			
			dist = Utils.HEIGHT - a.kinematic.position.y;
			if (a.kinematic.position.y < Globals.getPersonalSheepSpace())
			{
			currDir = new Vec2f(0,1);
			currDist = a.kinematic.position.y;
			weight = 1.0 - (currDist/Globals.getPersonalSheepSpace());
			direction = Utils.add(direction, Utils.mult(currDir,weight*wallAversion));
			}
			else if(dist < Globals.getPersonalSheepSpace())
			{
			   currDir = new Vec2f(0,-1);
			currDist = dist;
			weight = 1.0 - (currDist/Globals.getPersonalSheepSpace());
			direction = Utils.add(direction, Utils.mult(currDir,weight*wallAversion));
			}
			
			}
			*/

			var location:Vec2f = Utils.add(a.kinematic.position, direction);
			var fake:Bot = new Bot();
			fake.kinematic.position = location;
			var result:SteeringOutput = moveDelegate.getSteering(a,fake);
			result.strength = Utils.l2(direction);
			return result;
		}
	}
}