﻿package aibase
{
	import Math;
	internal class Kinematic
	{
		internal var position:Vec2f = new Vec2f(0,0);
		internal var orientation:Number;
		internal var velocity:Vec2f = new Vec2f(0,0);
		internal var rotation:Number;
		internal var maxSpeed:Number=100;
		internal var maxAcceleration:Number=300;//150;
		internal var maxRotation:Number=3 * Math.PI;
		internal var maxAngularAcceleration:Number=12 * Math.PI;
		internal var wanderOrientation:Number=0;
		internal var lastParam:Number=1;
		//todo: path

		function Kinematic(p_pos:Vec2f,p_or:Number,p_vel:Vec2f,p_rot:Number)
		{
			position=p_pos;
			orientation=p_or;
			velocity=p_vel;
			rotation=p_rot;
		}
		internal function toString():String
		{
			return "KI:[pos=" + position + ",orientation=" + orientation + ",velocity=" + velocity + ",rotataion=" + rotation + "]";
		}
		internal function update(p_steering:SteeringOutput , p_time:Number):void
		{
			position = Utils.add(Utils.mult(velocity , p_time),position);
			position = Utils.positionToTorus(position);

			orientation = orientation + (rotation * p_time);

			velocity = Utils.add(Utils.mult(p_steering.linear, p_time), velocity);
			if (Utils.l2(velocity) > maxSpeed)
			{
				velocity = Utils.scaleToLength(velocity,maxSpeed);
			}
			rotation += p_steering.angular * p_time;
			if (Math.abs(rotation) > maxRotation)
			{
				rotation = rotation > 0? maxRotation : -maxRotation;
			}
		}

	}
	
}