﻿/**
   ActionScript 3.0 Class for a simple path
   Written by Brian J. Stinar
   11/9/2008 
   For A.I. For Video Games Final Project with
   Jon Bradley
   
   This class is based on the "Simplepath" class implemented
   by Bill Klein for A.I. for Video Games, in Processing.
**/

package aibase{
	class SimplePath extends Path{
	
	public var points : Array = new Array();
	
	public function addPoint(x : Number, y : Number){
		var v : Vec2f = new Vec2f(x, y);
		points.push(v);
	}
	
	public override function getParam(position : Vec2f, lastParam : Number) : Number{
		var param : Number = 0;
		var bestdistance : Number = -1;
		var totallength : Number = 0;
		
		if (points.length > 0){
			 
			var start : Vec2f = new Vec2f(points[0].x, points[0].y);
			
			for (var i : int = 0; i < points.length; i++){
				var end : Vec2f = new Vec2f (points[i].x, points[i].y);
				var segmentlength : Number = Utils.Vec2fLength((Utils.difference(start, end)));
				
				var pt : Vec2f = findNearestPointOnLine(position, start, end);
				var newdistance : Number = Utils.Vec2fLength((Utils.difference(position, pt)));
				
				if ((bestdistance < 0 ) || (newdistance < bestdistance)){
					bestdistance = newdistance;
					param = totallength + Utils.Vec2fLength(Utils.difference(start, pt)); 
				} // end if 
				
				totallength = totallength + segmentlength;
				start = end;
			} // end for 
		 } // end if points.length > 0
		return param; 
	} // end getParam
	
	
	public function getPosition(p : Number) : Vec2f{
		var position : Vec2f; 
		var distance : Number = p;
		
		if (points.length > 0){
			
			position = points[0];
			var end : Vec2f; 
			
			for (var i : int = 1; i < points.length; i++){
				end = points[i];
				var diff : Vec2f = Utils.difference(position, end);
				
				if (Utils.Vec2fLength(diff) > distance){
					diff = Utils.scaleToLength(diff, distance);
					position = Utils.add(position, diff);
					return position;
				} // end if 
				
				else{
					distance = distance - Utils.Vec2fLength(diff);
					position = end;
				}
				
			} // end for points 1-n
			
		} // end if points.length > 0
	
		return position;
	}
	
	
	
	} // end class SimplePath
} // end package aibase