﻿package aibase
{
	internal class WallAvoidance implements Strategy
	{
		public static  const INSTANCE:WallAvoidance = new WallAvoidance();

		private var walls:Array = new Array(0);

		public function getName():String
		{
			return "WALL_AVOID";
		}
		
		public function setWalls(_walls:Array):void
		{
			walls = _walls;
		}
		public function getSteering(a:Bot, b:Bot):SteeringOutput
		{
			var here:Vec2f = a.kinematic.position;
			var there:Vec2f  = Utils.add(here, 
			Utils.scaleToLength(a.kinematic.velocity,Globals.WALL_AVOIDANCE()));
			var dir:Vec2f = new Vec2f(0,0);
			for (var x:int = 0; x<walls.length; x++)
			{
				var wall:Wall = walls[x];
				var res:Vec2f = Utils.LinesCross(here.x,here.y,there.x,there.y,
				wall.p1.x,wall.p1.y,wall.p2.x,wall.p2.y);
				if (res.x > -9999)
				{
					//trace("Intersect: "+res.toString());
					var toWall:Vec2f = Utils.peiceWise(wall.direction,Utils.difference(res,here));
					var weight:Number = (Utils.l2(toWall)/Globals.WALL_AVOIDANCE());
					dir = Utils.add(dir, Utils.scaleToLength(toWall,weight));
				}
			}
			var fake:Bot = new Bot();
			fake.kinematic.position = Utils.add(here, dir);
//if(Utils.l2(dir) > .001) trace(dir.toString());
			return DynamicSeek.INSTANCE.getSteering(a,fake);
		}
	}
}